/* appstream.vapi generated by valac 0.22.1, do not modify. */

namespace Appstream {
	namespace Provider {
	}
	namespace Utils {
	}
	[CCode (cheader_filename = "appstream.h")]
	public class AppInfo : GLib.Object {
		public AppInfo ();
		public void add_screenshot (Appstream.Screenshot sshot);
		public bool is_valid ();
		public void set_categories_from_str (string categories_str);
		public string to_string ();
		public string[] categories { get; set; }
		public string description { get; set; }
		public string desktop_file { get; set; }
		public string homepage { get; set; }
		public string icon { get; set; }
		public string icon_url { get; set; }
		public string[] keywords { get; set; }
		public string[] mimetypes { get; set; }
		public string name { get; set; }
		public string name_original { get; set; }
		public string pkgname { get; set; }
		public GLib.PtrArray screenshots { get; }
		public string summary { get; set; }
	}
	[CCode (cheader_filename = "appstream.h")]
	public class Category : GLib.Object {
		public Category ();
		public void add_subcategory (Appstream.Category cat);
		public bool has_subcategory ();
		public void remove_subcategory (Appstream.Category cat);
		public string directory { get; internal set; }
		public GLib.List<string> excluded { get; }
		public string icon { get; internal set; }
		public GLib.List<string> included { get; }
		public int level { get; internal set; }
		public string name { get; internal set; }
		public GLib.List<Appstream.Category> subcategories { get; }
		public string summary { get; private set; }
	}
	[CCode (cheader_filename = "appstream.h")]
	public class Database : GLib.Object {
		public Database ();
		public bool db_exists ();
		public GLib.PtrArray? find_applications (Appstream.SearchQuery query);
		public GLib.PtrArray? find_applications_by_str (string search_str, string? categories_str = null);
		public GLib.PtrArray? get_all_applications ();
		public virtual bool open ();
		public string database_path { get; internal set; }
	}
	[CCode (cheader_filename = "appstream.h")]
	public class DistroDetails : GLib.Object {
		public DistroDetails ();
		public bool config_distro_get_bool (string key);
		public string? config_distro_get_str (string key);
		[CCode (array_length = false, array_null_terminated = true)]
		public string[] get_icon_repository_paths ();
		public string distro_id { get; private set; }
		public string distro_name { get; private set; }
		public string distro_version { get; private set; }
	}
	[CCode (cheader_filename = "appstream.h")]
	public class MenuParser {
		public MenuParser ();
		public MenuParser.from_file (string menu_file);
		public GLib.List<Appstream.Category>? parse ();
		public bool update_category_data { get; set; }
	}
	[CCode (cheader_filename = "appstream.h")]
	public class Screenshot : GLib.Object {
		public GLib.HashTable<string,string> thumbnail_urls;
		public GLib.HashTable<string,string> urls;
		public Screenshot ();
		public void add_thumbnail_url (string size_id, string url);
		public void add_url (string size_id, string url);
		[CCode (array_length = false, array_null_terminated = true)]
		public string[] get_available_sizes ();
		[CCode (array_length = false, array_null_terminated = true)]
		public string[] get_available_thumbnail_sizes ();
		public string? get_thumbnail_url_for_size (string size_id);
		public string? get_url_for_size (string size_id);
		public bool is_default ();
		public bool is_valid ();
		public void set_default (bool b);
		public string caption { get; set; }
	}
	[CCode (cheader_filename = "appstream.h")]
	public class ScreenshotService : GLib.Object {
		public ScreenshotService ();
		public string get_screenshot_url (string package_name);
		public string get_thumbnail_url (string package_name);
		public string base_url { get; private set; }
	}
	[CCode (cheader_filename = "appstream.h")]
	public class SearchQuery : GLib.Object {
		public SearchQuery (string term = "");
		public bool get_search_all_categories ();
		public void set_categories_from_string (string categories_str);
		public void set_search_all_categories ();
		public string[] categories { get; set; }
		public string search_term { get; set; }
	}
	[CCode (cheader_filename = "appstream.h")]
	public static GLib.List<Appstream.Category> get_system_categories ();
}
